## cubeb 0.0~git20240307.5491fc8+ds

=== debian/changelog ===
cubeb (0.0~git20240307.5491fc8+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20240307.5491fc8+ds
    - Support sound cards running at 384kHz
  * d/s/lintian-overrides: override pkg-config => pkgconf

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 10 Mar 2024 16:13:18 +0100

## cubeb 0.0~git20240524.dabff20+ds

=== CMakeLists.txt ===
# TODO
# - backend selection via command line, rather than simply detecting headers.

cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
project(cubeb
  VERSION 0.0.0)

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
option(BUILD_TESTS "Build tests" ON)
option(BUILD_RUST_LIBS "Build rust backends" OFF)
option(BUILD_TOOLS "Build tools" ON)
option(BUNDLE_SPEEX "Bundle the speex library" OFF)
option(LAZY_LOAD_LIBS "Lazily load shared libraries" ON)
option(USE_SANITIZERS "Use sanitizers" ON)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

if(USE_SANITIZERS)
  if(NOT COMMAND add_sanitizers)
    list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/sanitizers-cmake/cmake")
    find_package(Sanitizers)
    if(NOT COMMAND add_sanitizers)
      message(FATAL_ERROR "Could not find sanitizers-cmake: run\n\tgit submodule update --init --recursive\nin base git checkout")
    endif()
  endif()
else()
  macro(add_sanitizers UNUSED)
  endmacro()
endif()

if(BUILD_TESTS)
  find_package(GTest QUIET)
  if(TARGET GTest::Main)
    add_library(gtest_main ALIAS GTest::Main)
  endif()
  if(NOT TARGET gtest_main)
    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/googletest/CMakeLists.txt")
      message(FATAL_ERROR "Could not find googletest: run\n\tgit submodule update --init --recursive\nin base git checkout")
    endif()
    add_definitions(-DGTEST_HAS_TR1_TUPLE=0 -DGTEST_HAS_RTTI=0)
    set(gtest_force_shared_crt ON CACHE BOOL "")
    add_subdirectory(googletest)
  endif()
endif()

if (BUILD_RUST_LIBS)
  if(EXISTS "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs")
    set(USE_PULSE_RUST 1)
  endif()
  if(EXISTS "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs")
    set(USE_AUDIOUNIT_RUST 1)
  endif()
endif()

# On OS/2, visibility attribute is not supported.
if(NOT OS2)
  set(CMAKE_C_VISIBILITY_PRESET hidden)
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)
  set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif()

set(CMAKE_CXX_WARNING_LEVEL 4)
if(NOT MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -fno-exceptions -fno-rtti")
else()
  string(REPLACE "/GR" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}") # Disable RTTI
  string(REPLACE "/EHsc" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}") # Disable Exceptions
endif()

add_library(cubeb
  src/cubeb.c
  src/cubeb_audio_dump.cpp
  src/cubeb_mixer.cpp
  src/cubeb_resampler.cpp
  src/cubeb_log.cpp
  src/cubeb_strings.c
  src/cubeb_utils.cpp
)
target_include_directories(cubeb
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>
)
set_target_properties(cubeb PROPERTIES
  VERSION ${cubeb_VERSION}
  SOVERSION ${cubeb_VERSION_MAJOR}
)

add_sanitizers(cubeb)

include(GenerateExportHeader)
generate_export_header(cubeb EXPORT_FILE_NAME ${CMAKE_BINARY_DIR}/exports/cubeb_export.h)
target_include_directories(cubeb
  PUBLIC $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/exports>
)

include(GNUInstallDirs)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/${PROJECT_NAME} TYPE INCLUDE)
install(DIRECTORY ${CMAKE_BINARY_DIR}/exports/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
  "Config.cmake.in"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

install(
  FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake" "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

install(TARGETS cubeb EXPORT "${PROJECT_NAME}Targets")
install(
  EXPORT "${PROJECT_NAME}Targets"
  NAMESPACE "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

if(NOT BUNDLE_SPEEX)
  find_package(PkgConfig)
  if(PKG_CONFIG_FOUND)
    pkg_check_modules(speexdsp IMPORTED_TARGET speexdsp)
    if(speexdsp_FOUND)
      add_library(speex ALIAS PkgConfig::speexdsp)
    endif()
  endif()
endif()

if(NOT TARGET speex)
  add_library(speex OBJECT subprojects/speex/resample.c)
  set_target_properties(speex PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
  target_include_directories(speex INTERFACE subprojects)
  target_compile_definitions(speex PUBLIC
    OUTSIDE_SPEEX
    FLOATING_POINT
    EXPORT=
    RANDOM_PREFIX=speex
  )
endif()

# $<BUILD_INTERFACE:> required because of https://gitlab.kitware.com/cmake/cmake/-/issues/15415
target_link_libraries(cubeb PRIVATE $<BUILD_INTERFACE:speex>)

include(CheckIncludeFiles)

# Threads needed by cubeb_log, _pulse, _alsa, _jack, _sndio, _oss and _sun
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads)
target_link_libraries(cubeb PRIVATE Threads::Threads)

if(LAZY_LOAD_LIBS)
  check_include_files(pulse/pulseaudio.h USE_PULSE)
  check_include_files(alsa/asoundlib.h   USE_ALSA)
  check_include_files(jack/jack.h        USE_JACK)
  check_include_files(sndio.h            USE_SNDIO)
  check_include_files(aaudio/AAudio.h    USE_AAUDIO)

  if(USE_PULSE OR USE_ALSA OR USE_JACK OR USE_SNDIO OR USE_AAUDIO)
    target_link_libraries(cubeb PRIVATE ${CMAKE_DL_LIBS})

    if(ANDROID)
      target_compile_definitions(cubeb PRIVATE __ANDROID_UNAVAILABLE_SYMBOLS_ARE_WEAK__)
    endif()
  endif()

else()

  find_package(PkgConfig REQUIRED)

  pkg_check_modules(libpulse IMPORTED_TARGET libpulse)
  if(libpulse_FOUND)
    set(USE_PULSE ON)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBPULSE_DLOPEN)
    target_link_libraries(cubeb PRIVATE PkgConfig::libpulse)
  endif()

  pkg_check_modules(alsa IMPORTED_TARGET alsa)
  if(alsa_FOUND)
    set(USE_ALSA ON)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBASOUND_DLOPEN)
    target_link_libraries(cubeb PRIVATE PkgConfig::alsa)
  endif()

  pkg_check_modules(jack IMPORTED_TARGET jack)
  if(jack_FOUND)
    set(USE_JACK ON)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBJACK_DLOPEN)
    target_link_libraries(cubeb PRIVATE PkgConfig::jack)
  endif()

  check_include_files(sndio.h USE_SNDIO)
  if(USE_SNDIO)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBSNDIO_DLOPEN)
    target_link_libraries(cubeb PRIVATE sndio)
  endif()

  check_include_files(aaudio/AAudio.h USE_AAUDIO)
  if(USE_AAUDIO)
    target_compile_definitions(cubeb PRIVATE DISABLE_LIBAAUDIO_DLOPEN)
    target_link_libraries(cubeb PRIVATE aaudio)
  endif()
endif()

if(USE_PULSE)
  target_sources(cubeb PRIVATE src/cubeb_pulse.c)
  target_compile_definitions(cubeb PRIVATE USE_PULSE)
endif()

if(USE_ALSA)
  target_sources(cubeb PRIVATE src/cubeb_alsa.c)
  target_compile_definitions(cubeb PRIVATE USE_ALSA)
endif()

if(USE_JACK)
  target_sources(cubeb PRIVATE src/cubeb_jack.cpp)
  target_compile_definitions(cubeb PRIVATE USE_JACK)
endif()

if(USE_SNDIO)
  target_sources(cubeb PRIVATE src/cubeb_sndio.c)
  target_compile_definitions(cubeb PRIVATE USE_SNDIO)
endif()

if(USE_AAUDIO)
  target_sources(cubeb PRIVATE src/cubeb_aaudio.cpp)
  target_compile_definitions(cubeb PRIVATE USE_AAUDIO)

  # set this definition to enable low latency mode. Possibly bad for battery
  target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_LOW_LATENCY)

  # set this definition to enable power saving mode. Possibly resulting
  # in high latency
  # target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_LOW_POWER_SAVING)

  # set this mode to make the backend use an exclusive stream.
  # will decrease latency.
  # target_compile_definitions(cubeb PRIVATE CUBEB_AAUDIO_EXCLUSIVE_STREAM)
endif()

check_include_files(AudioUnit/AudioUnit.h USE_AUDIOUNIT)
if(USE_AUDIOUNIT)
  target_sources(cubeb PRIVATE
    src/cubeb_audiounit.cpp
    src/cubeb_osx_run_loop.cpp)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT)
  target_link_libraries(cubeb PRIVATE "-framework AudioUnit" "-framework CoreAudio" "-framework CoreServices")
endif()

check_include_files(audioclient.h USE_WASAPI)
if(USE_WASAPI)
  target_sources(cubeb PRIVATE
    src/cubeb_wasapi.cpp)
  target_compile_definitions(cubeb PRIVATE USE_WASAPI)
  target_link_libraries(cubeb PRIVATE avrt ole32 ksuser)
endif()

check_include_files("windows.h;mmsystem.h" USE_WINMM)
if(USE_WINMM)
  target_sources(cubeb PRIVATE
    src/cubeb_winmm.c)
  target_compile_definitions(cubeb PRIVATE USE_WINMM)
  target_link_libraries(cubeb PRIVATE winmm)
endif()

check_include_files(SLES/OpenSLES.h USE_OPENSL)
if(USE_OPENSL)
  target_sources(cubeb PRIVATE
    src/cubeb_opensl.cpp
    src/cubeb-jni.cpp)
  target_compile_definitions(cubeb PRIVATE USE_OPENSL)
  target_link_libraries(cubeb PRIVATE OpenSLES)
endif()

check_include_files(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
if(HAVE_SYS_SOUNDCARD_H)
  try_compile(USE_OSS "${PROJECT_BINARY_DIR}/compile_tests"
    ${PROJECT_SOURCE_DIR}/cmake/compile_tests/oss_is_v4.c)
  if(USE_OSS)
    # strlcpy is not available on BSD systems that use glibc,
    # like Debian kfreebsd, so try using libbsd if available
    include(CheckSymbolExists)
    check_symbol_exists(strlcpy string.h HAVE_STRLCPY)
    if(NOT HAVE_STRLCPY)
      pkg_check_modules(libbsd-overlay IMPORTED_TARGET libbsd-overlay)
      if(libbsd-overlay_FOUND)
        target_link_libraries(cubeb PRIVATE PkgConfig::libbsd-overlay)
        set(HAVE_STRLCPY true)
      endif()
    endif()
    if (HAVE_STRLCPY)
      target_sources(cubeb PRIVATE
        src/cubeb_oss.c)
      target_compile_definitions(cubeb PRIVATE USE_OSS)
    endif()
  endif()
endif()

check_include_files(android/log.h USE_AUDIOTRACK)
if(USE_AUDIOTRACK)
  target_sources(cubeb PRIVATE
    src/cubeb_audiotrack.c)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOTRACK)
  target_link_libraries(cubeb PRIVATE log)
endif()

check_include_files(sys/audioio.h USE_SUN)
if(USE_SUN)
  target_sources(cubeb PRIVATE
    src/cubeb_sun.c)
  target_compile_definitions(cubeb PRIVATE USE_SUN)
endif()

check_include_files(kai.h USE_KAI)
if(USE_KAI)
  target_sources(cubeb PRIVATE
    src/cubeb_kai.c)
  target_compile_definitions(cubeb PRIVATE USE_KAI)
  target_link_libraries(cubeb PRIVATE kai)
endif()

if(USE_PULSE AND USE_PULSE_RUST)
  include(ExternalProject)
  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/rust)
  ExternalProject_Add(
    cubeb_pulse_rs
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND ""
    BUILD_COMMAND cargo build COMMAND cargo build --release
    BUILD_ALWAYS ON
    BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
    INSTALL_COMMAND ""
    LOG_BUILD ON)
  add_dependencies(cubeb cubeb_pulse_rs)
  target_compile_definitions(cubeb PRIVATE USE_PULSE_RUST)
  target_link_libraries(cubeb PRIVATE
    debug "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/debug/libcubeb_pulse.a"
    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/release/libcubeb_pulse.a" pulse)
endif()

if(USE_AUDIOUNIT AND USE_AUDIOUNIT_RUST)
  include(ExternalProject)
  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/rust)
  ExternalProject_Add(
    cubeb_coreaudio_rs
    DOWNLOAD_COMMAND ""
    CONFIGURE_COMMAND ""
    BUILD_COMMAND cargo build COMMAND cargo build --release
    BUILD_ALWAYS ON
    BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
    INSTALL_COMMAND ""
    LOG_BUILD ON)
  add_dependencies(cubeb cubeb_coreaudio_rs)
  target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT_RUST)
  target_link_libraries(cubeb PRIVATE
    debug "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs/target/debug/libcubeb_coreaudio.a"
    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs/target/release/libcubeb_coreaudio.a")
endif()

find_package(Doxygen)
if(DOXYGEN_FOUND)

=== debian/changelog ===
cubeb (0.0~git20240524.dabff20+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20240524.dabff20+ds
    - Support sound cards running at 768kHz

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 01 Jun 2024 13:57:11 +0200

## cubeb 0.0~git20240704.89573c9+ds

=== debian/changelog ===
cubeb (0.0~git20240704.89573c9+ds-1) unstable; urgency=medium

  * New upstream version 0.0~git20240704.89573c9+ds
  * First dgit push

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 06 Jul 2024 16:59:04 +0200

## cubeb 0.0~git20250108.048f4a0+ds

=== debian/changelog ===
cubeb (0.0~git20250108.048f4a0+ds-1) unstable; urgency=low

  * New upstream version 0.0~git20250108.048f4a0+ds
  * d/control: apply X-Style: black
  * d/control: declare dpkg-build-api (= 1)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 12 Jan 2025 00:10:17 +0100

=== debian/control ===
Source: cubeb
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
 cmake (>= 3.14),
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 libasound2-dev [linux-any],
 libbsd-dev [kfreebsd-any],
 libjack-jackd2-dev,
 libpulse-dev,
 libsndio-dev,
 libspeexdsp-dev,
 pkg-config,
Build-Conflicts:
 libasound2-dev [!linux-any],
Standards-Version: 4.7.0
Homepage: https://github.com/mozilla/cubeb
Vcs-Git: https://salsa.debian.org/debian/cubeb.git
Vcs-Browser: https://salsa.debian.org/debian/cubeb
X-Style: black

Package: libcubeb0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: cross platform audio library
 cubeb is a cross platform audio library most notable for its use as
 the audio backend within Gecko, Mozilla's browser engine. It supports
 multiple audio backends and allows enumeration of audio devices and
 opening audio streams with control over latency, sample rate and more.
 .
 This package contains the shared library.

Package: libcubeb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libcubeb0 (= ${binary:Version}),
 libspeexdsp-dev,
 ${misc:Depends},
Recommends:
 libcubeb-doc,
Description: cross platform audio library - development files
 cubeb is a cross platform audio library most notable for its use as
 the audio backend within Gecko, Mozilla's browser engine. It supports
 multiple audio backends and allows enumeration of audio devices and
 opening audio streams with control over latency, sample rate and more.
 .
 This package contains the development files.

Package: libcubeb-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 libjs-jquery,
Description: cross platform audio library - documentation
 cubeb is a cross platform audio library most notable for its use as
 the audio backend within Gecko, Mozilla's browser engine. It supports
 multiple audio backends and allows enumeration of audio devices and
 opening audio streams with control over latency, sample rate and more.
 .
 This package contains the generated Doxygen documentation.

## cubeb 0.0~git20250127.2816b5a+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
 # TODO
 # - backend selection via command line, rather than simply detecting headers.
 
-cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
+cmake_policy(SET CMP0091 NEW)
 project(cubeb
   VERSION 0.0.0)
 
@@ -12,6 +13,10 @@
 option(BUNDLE_SPEEX "Bundle the speex library" OFF)
 option(LAZY_LOAD_LIBS "Lazily load shared libraries" ON)
 option(USE_SANITIZERS "Use sanitizers" ON)
+option(USE_STATIC_MSVC_RUNTIME "Use /MT instead of /MD in MSVC" OFF)
+if(USE_STATIC_MSVC_RUNTIME)
+    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+endif()
 
 if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
@@ -339,7 +344,7 @@
     cubeb_pulse_rs
     DOWNLOAD_COMMAND ""
     CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build COMMAND cargo build --release
+    BUILD_COMMAND cargo build --features=gecko-in-tree COMMAND cargo build --release --features=gecko-in-tree
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
     INSTALL_COMMAND ""
@@ -358,7 +363,7 @@
     cubeb_coreaudio_rs
     DOWNLOAD_COMMAND ""
     CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build COMMAND cargo build --release
+    BUILD_COMMAND cargo build --features=gecko-in-tree COMMAND cargo build --release --features=gecko-in-tree
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
     INSTALL_COMMAND ""
@@ -366,9 +371,3 @@
   add_dependencies(cubeb cubeb_coreaudio_rs)
   target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT_RUST)
   target_link_libraries(cubeb PRIVATE
-    debug "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs/target/debug/libcubeb_coreaudio.a"
-    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs/target/release/libcubeb_coreaudio.a")
-endif()
-
-find_package(Doxygen)
-if(DOXYGEN_FOUND)

=== debian/changelog ===
cubeb (0.0~git20250127.2816b5a+ds-1) unstable; urgency=low

  * New upstream version 0.0~git20250127.2816b5a+ds
  * d: document packaging workflow in README.source
  * d/control: set maintainer to my @debian.org address

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 28 Jan 2025 17:41:37 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: cubeb
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Andrea Pappacoda <tachi@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dpkg-build-api (= 1),

## cubeb 0.0~git20250203.224b7cb+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -344,11 +344,12 @@
     cubeb_pulse_rs
     DOWNLOAD_COMMAND ""
     CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build --features=gecko-in-tree COMMAND cargo build --release --features=gecko-in-tree
+    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release>,--release,>"
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
     INSTALL_COMMAND ""
-    LOG_BUILD ON)
+    LOG_BUILD ON
+    LOG_OUTPUT_ON_FAILURE ON)
   add_dependencies(cubeb cubeb_pulse_rs)
   target_compile_definitions(cubeb PRIVATE USE_PULSE_RUST)
   target_link_libraries(cubeb PRIVATE
@@ -363,11 +364,11 @@
     cubeb_coreaudio_rs
     DOWNLOAD_COMMAND ""
     CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build --features=gecko-in-tree COMMAND cargo build --release --features=gecko-in-tree
+    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release>,--release,>"
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
     INSTALL_COMMAND ""
-    LOG_BUILD ON)
+    LOG_BUILD ON
+    LOG_OUTPUT_ON_FAILURE ON)
   add_dependencies(cubeb cubeb_coreaudio_rs)
   target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT_RUST)
-  target_link_libraries(cubeb PRIVATE

=== debian/changelog ===
cubeb (0.0~git20250203.224b7cb+ds-1) unstable; urgency=low

  [ Andrea Pappacoda ]
  * New upstream version 0.0~git20250203.224b7cb+ds

  [ Niels Thykier ]
  * Migrate to debputy (full-integration)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 09 Feb 2025 18:44:12 +0100

## cubeb 0.0~git20250401.975a727+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -344,7 +344,7 @@
     cubeb_pulse_rs
     DOWNLOAD_COMMAND ""
     CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release>,--release,>"
+    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release,RelWithDebInfo,MinSizeRel>,--release,>"
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
     INSTALL_COMMAND ""
@@ -364,11 +364,10 @@
     cubeb_coreaudio_rs
     DOWNLOAD_COMMAND ""
     CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release>,--release,>"
+    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release,RelWithDebInfo,MinSizeRel>,--release,>"
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
     INSTALL_COMMAND ""
     LOG_BUILD ON
     LOG_OUTPUT_ON_FAILURE ON)
   add_dependencies(cubeb cubeb_coreaudio_rs)
-  target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT_RUST)

=== debian/changelog ===
cubeb (0.0~git20250401.975a727+ds-1) unstable; urgency=low

  * New upstream version 0.0~git20250401.975a727+ds

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 09 Apr 2025 15:09:57 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Andrea Pappacoda <tachi@debian.org>
+Build-Driver: debputy
 Build-Depends:
- debhelper-compat (= 13),
+ debputy (>= 0.1.61~),
  dpkg-build-api (= 1),
+ dpkg-dev (>= 1.22.7~),
  cmake (>= 3.14),
  doxygen <!nodoc>,
  graphviz <!nodoc>,
@@ -26,11 +28,6 @@
 Package: libcubeb0
 Architecture: any
 Multi-Arch: same
-Pre-Depends:
- ${misc:Pre-Depends},
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
 Description: cross platform audio library
  cubeb is a cross platform audio library most notable for its use as
  the audio backend within Gecko, Mozilla's browser engine. It supports
@@ -63,8 +60,6 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
-Depends:
- ${misc:Depends},
 Recommends:
  libjs-jquery,
 Description: cross platform audio library - documentation

=== debian/tests/control ===
Tests:
 compile,
Depends:
 cmake,
 g++ | c++-compiler,
 @,

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, repacksuffix=+ds, dversionmangle=auto" \
https://github.com/mozilla/cubeb.git \
HEAD debian uupdate

## cubeb 0.0~git20250529.78ee5f0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,17 @@
       "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
 endif()
 
+set(private_requires)
+set(private_libs)
+set(private_libs_flags)
+if(UNIX AND NOT APPLE)
+  if(BSD OR ANDROID)
+    list(APPEND private_libs c++)
+  else()
+    list(APPEND private_libs stdc++)
+  endif()
+endif()
+
 set(CMAKE_C_STANDARD 99)
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -91,7 +102,7 @@
   src/cubeb_utils.cpp
 )
 target_include_directories(cubeb
-  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>
+  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
 )
 set_target_properties(cubeb PROPERTIES
   VERSION ${cubeb_VERSION}
@@ -141,6 +152,7 @@
     pkg_check_modules(speexdsp IMPORTED_TARGET speexdsp)
     if(speexdsp_FOUND)
       add_library(speex ALIAS PkgConfig::speexdsp)
+      list(APPEND private_requires speexdsp)
     endif()
   endif()
 endif()
@@ -155,6 +167,7 @@
     EXPORT=
     RANDOM_PREFIX=speex
   )
+  list(APPEND private_libs speex)
 endif()
 
 # $<BUILD_INTERFACE:> required because of https://gitlab.kitware.com/cmake/cmake/-/issues/15415
@@ -166,6 +179,7 @@
 set(THREADS_PREFER_PTHREAD_FLAG ON)
 find_package(Threads)
 target_link_libraries(cubeb PRIVATE Threads::Threads)
+list(APPEND private_libs ${CMAKE_THREAD_LIBS_INIT})
 
 if(LAZY_LOAD_LIBS)
   check_include_files(pulse/pulseaudio.h USE_PULSE)
@@ -176,6 +190,7 @@
 
   if(USE_PULSE OR USE_ALSA OR USE_JACK OR USE_SNDIO OR USE_AAUDIO)
     target_link_libraries(cubeb PRIVATE ${CMAKE_DL_LIBS})
+    list(APPEND private_libs ${CMAKE_DL_LIBS})
 
     if(ANDROID)
       target_compile_definitions(cubeb PRIVATE __ANDROID_UNAVAILABLE_SYMBOLS_ARE_WEAK__)
@@ -191,6 +206,7 @@
     set(USE_PULSE ON)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBPULSE_DLOPEN)
     target_link_libraries(cubeb PRIVATE PkgConfig::libpulse)
+    list(APPEND private_requires libpulse)
   endif()
 
   pkg_check_modules(alsa IMPORTED_TARGET alsa)
@@ -198,6 +214,7 @@
     set(USE_ALSA ON)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBASOUND_DLOPEN)
     target_link_libraries(cubeb PRIVATE PkgConfig::alsa)
+    list(APPEND private_requires alsa)
   endif()
 
   pkg_check_modules(jack IMPORTED_TARGET jack)
@@ -205,18 +222,21 @@
     set(USE_JACK ON)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBJACK_DLOPEN)
     target_link_libraries(cubeb PRIVATE PkgConfig::jack)
+    list(APPEND private_requires jack)
   endif()
 
   check_include_files(sndio.h USE_SNDIO)
   if(USE_SNDIO)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBSNDIO_DLOPEN)
     target_link_libraries(cubeb PRIVATE sndio)
+    list(APPEND private_libs sndio)
   endif()
 
   check_include_files(aaudio/AAudio.h USE_AAUDIO)
   if(USE_AAUDIO)
     target_compile_definitions(cubeb PRIVATE DISABLE_LIBAAUDIO_DLOPEN)
     target_link_libraries(cubeb PRIVATE aaudio)
+    list(APPEND private_libs aaudio)
   endif()
 endif()
 
@@ -263,6 +283,7 @@
     src/cubeb_osx_run_loop.cpp)
   target_compile_definitions(cubeb PRIVATE USE_AUDIOUNIT)
   target_link_libraries(cubeb PRIVATE "-framework AudioUnit" "-framework CoreAudio" "-framework CoreServices")
+  list(APPEND private_libs_flags "-framework AudioUnit" "-framework CoreAudio" "-framework CoreServices")
 endif()
 
 check_include_files(audioclient.h USE_WASAPI)
@@ -271,6 +292,7 @@
     src/cubeb_wasapi.cpp)
   target_compile_definitions(cubeb PRIVATE USE_WASAPI)
   target_link_libraries(cubeb PRIVATE avrt ole32 ksuser)
+  list(APPEND private_libs avrt ole32 ksuser)
 endif()
 
 check_include_files("windows.h;mmsystem.h" USE_WINMM)
@@ -279,6 +301,7 @@
     src/cubeb_winmm.c)
   target_compile_definitions(cubeb PRIVATE USE_WINMM)
   target_link_libraries(cubeb PRIVATE winmm)
+  list(APPEND private_libs winmm)
 endif()
 
 check_include_files(SLES/OpenSLES.h USE_OPENSL)
@@ -288,6 +311,7 @@
     src/cubeb-jni.cpp)
   target_compile_definitions(cubeb PRIVATE USE_OPENSL)
   target_link_libraries(cubeb PRIVATE OpenSLES)
+  list(APPEND private_libs OpenSLES)
 endif()
 
 check_include_files(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
@@ -303,6 +327,7 @@
       pkg_check_modules(libbsd-overlay IMPORTED_TARGET libbsd-overlay)
       if(libbsd-overlay_FOUND)
         target_link_libraries(cubeb PRIVATE PkgConfig::libbsd-overlay)
+        list(APPEND private_requires libbsd-overlay)
         set(HAVE_STRLCPY true)
       endif()
     endif()
@@ -320,6 +345,7 @@
     src/cubeb_audiotrack.c)
   target_compile_definitions(cubeb PRIVATE USE_AUDIOTRACK)
   target_link_libraries(cubeb PRIVATE log)
+  list(APPEND private_libs log)
 endif()
 
 check_include_files(sys/audioio.h USE_SUN)
@@ -335,6 +361,7 @@
     src/cubeb_kai.c)
   target_compile_definitions(cubeb PRIVATE USE_KAI)
   target_link_libraries(cubeb PRIVATE kai)
+  list(APPEND private_libs kai)
 endif()
 
 if(USE_PULSE AND USE_PULSE_RUST)
@@ -348,26 +375,3 @@
     BUILD_ALWAYS ON
     BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs"
     INSTALL_COMMAND ""
-    LOG_BUILD ON
-    LOG_OUTPUT_ON_FAILURE ON)
-  add_dependencies(cubeb cubeb_pulse_rs)
-  target_compile_definitions(cubeb PRIVATE USE_PULSE_RUST)
-  target_link_libraries(cubeb PRIVATE
-    debug "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/debug/libcubeb_pulse.a"
-    optimized "${PROJECT_SOURCE_DIR}/src/cubeb-pulse-rs/target/release/libcubeb_pulse.a" pulse)
-endif()
-
-if(USE_AUDIOUNIT AND USE_AUDIOUNIT_RUST)
-  include(ExternalProject)
-  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/rust)
-  ExternalProject_Add(
-    cubeb_coreaudio_rs
-    DOWNLOAD_COMMAND ""
-    CONFIGURE_COMMAND ""
-    BUILD_COMMAND cargo build --features=gecko-in-tree "$<IF:$<CONFIG:Release,RelWithDebInfo,MinSizeRel>,--release,>"
-    BUILD_ALWAYS ON
-    BINARY_DIR "${PROJECT_SOURCE_DIR}/src/cubeb-coreaudio-rs"
-    INSTALL_COMMAND ""
-    LOG_BUILD ON
-    LOG_OUTPUT_ON_FAILURE ON)
-  add_dependencies(cubeb cubeb_coreaudio_rs)

=== debian/changelog ===
cubeb (0.0~git20250529.78ee5f0+ds-2) experimental; urgency=low

  * d/debputy.manifest: add missing pkgconfig directory

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 03 Jun 2025 10:11:50 +0200

cubeb (0.0~git20250529.78ee5f0+ds-1) experimental; urgency=low

  * New upstream version 0.0~git20250529.78ee5f0+ds
    - Add pkg-config file generation
    - Add cubeb_get_backend_names

 -- Andrea Pappacoda <tachi@debian.org>  Mon, 02 Jun 2025 15:51:41 +0200

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  pkg-config,
 Build-Conflicts:
  libasound2-dev [!linux-any],
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/mozilla/cubeb
 Vcs-Git: https://salsa.debian.org/debian/cubeb.git
 Vcs-Browser: https://salsa.debian.org/debian/cubeb
